-- (poorly) Flat-shaded Cube 
-- /Mic, 1999/2000  

without warning

include triangle.e
include stuff.e
include vesa20.e
include graphics.e
include 3dmath.e
include colors.e

sequence points,points2
sequence faces,order,zNormals
sequence pal,shades
sequence v,dv
sequence foi,soi,c
integer faceCol
integer XDIM,YDIM,XCENTRE,YCENTRE,SIZE,BPP,key
integer c1,c2
atom vscreen
atom time1,time2,frames
integer wait_retrace


points2 = 
{
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}


wait_retrace = 1
puts(1,"Flat-shaded Cube for Euphoria 2.1+\n")
puts(1,"By Mic, 1999/2000\n\n")
puts(1,"Choose a graphics mode:\n")
puts(1," [1] 320*240  (8-bit)\n [2] 640*480  (8-bit)\n [3] 800*600  (8-bit)\n [4] 1024*768 (8-bit)\n")
puts(1," [5] 320*240  (16-bit)\n [6] 640*480  (16-bit)\n [7] 800*600  (16-bit)\n [8] 1024*768 (16-bit)\n")
puts(1," [9] 320*240  (24-bit)\n [a] 640*480  (24-bit)\n [b] 800*600  (24-bit)\n [c] 1024*768 (24-bit)\n [0] Abort mission\n")
puts(1,"Vertical retrace: ON  ([+]=ON [-]=OFF)\n")
puts(1,"\n\nDuring the demonstration:\n")
puts(1," [-] Zoom in\n [+] Zoom out\n [Esc] Exit\n")
key=0
while ((key<'0') or (key>'9')) and ((key<'a') or (key>'c')) do
 key=get_key()
 if key='+' then
  position(18,19)
  puts(1,"ON ")
  wait_retrace=1
 elsif key='-' then
  position(18,19)
  puts(1,"OFF")
  wait_retrace=0
 end if  
end while

if key='0' then
 abort(0)
elsif key='1' then
 XDIM = 320
 YDIM = 240
 XCENTRE = 160
 YCENTRE = 120
 SIZE = 49
 BPP = 8
elsif key='2' then
 XDIM = 640
 YDIM = 480
 XCENTRE = 320
 YCENTRE = 240
 SIZE = 70
 BPP = 8
elsif key='3' then
 XDIM = 800
 YDIM = 600
 XCENTRE = 400
 YCENTRE = 300
 SIZE = 75
 BPP = 8
elsif key='4' then
 XDIM = 1024
 YDIM = 768
 XCENTRE = 512
 YCENTRE = 384
 SIZE = 75
 BPP = 8
elsif key='5' then
 XDIM = 320
 YDIM = 240
 XCENTRE = 160
 YCENTRE = 120
 SIZE = 49
 BPP = 16
elsif key='6' then
 XDIM = 640
 YDIM = 480
 XCENTRE = 320
 YCENTRE = 240
 SIZE = 70
 BPP = 16
elsif key='7' then
 XDIM = 800
 YDIM = 600
 XCENTRE = 400
 YCENTRE = 300
 SIZE = 75
 BPP = 16
elsif key='8' then
 XDIM = 1024
 YDIM = 768
 XCENTRE = 512
 YCENTRE = 384
 SIZE = 75
 BPP = 16
elsif key='9' then
 XDIM = 320
 YDIM = 240
 XCENTRE = 160
 YCENTRE = 120
 SIZE = 49
 BPP = 24
elsif key='a' then
 XDIM = 640
 YDIM = 480
 XCENTRE = 320
 YCENTRE = 240
 SIZE = 70
 BPP = 24
elsif key='b' then
 XDIM  =800
 YDIM = 600
 XCENTRE = 400
 YCENTRE = 300
 SIZE = 75
 BPP = 24
elsif key='c' then
 XDIM = 1024
 YDIM = 768
 XCENTRE = 512
 YCENTRE = 384
 SIZE = 75
 BPP = 24
end if

camX = XCENTRE
camY = YCENTRE

constant P=(SIZE-9)*1.5, SPAN=(P*2)+1
points2 *= (SIZE-9)
SIZE += SIZE

pal = repeat({0,0,0},256)
for i = 1 to 63 do
  pal[i] = {floor(i/6),floor(i/6),i}
  pal[i+63] = {i,floor(i/6),i}
  pal[i+126] = {floor(i/6),i,i}
end for
if BPP=8 then
 shades =
 {{0},{0},{64},{128},{64},{128}}
elsif BPP=16 then
 shades = 
 {
  {255,127,0},{76,178,25},{51,255,204},{25,102,255},{0,255,178},{153,51,255}
 }
elsif BPP=24 then
 shades = 
 {
  {255,76,76},{255,76,76},{76,255,76},{76,76,255},{76,255,76},{76,76,255}
 }
end if

if vesa_mode(XDIM,YDIM,BPP) then
  puts(2,"Doh! Unable to set graphics mode!\n")
  puts(2,"Possible reasons:\n * No VESA driver installed.\n * Your videocard sucks..\n")
  abort(1)
end if
if mode_type=BANKED then
  puts(2,"Doh! Unable to get a linear framebuffer!\n")
  abort(1) 
end if

 
if render_mode(XDIM,YDIM,bits_per_pixel) then end if
vscreen = allocate(XDIM*YDIM*(BPP/8))		--allocate a virtual screen
if vscreen=0 then
  puts(2,"Doh! Unable to allocate memory for virtual screen!\n")
  abort(1)
end if
cls(vscreen,0)
if BPP=8 then set_pal(pal) end if 


v = {30,30,30}
dv = {1,1,1}
frames = 0
time1 = time()
key = 0

--!!!! main loop !!!!
while key!=27 do 
  key = get_key()
  clear_area(vscreen,0,{{XCENTRE-SIZE,YCENTRE-SIZE},{XCENTRE+SIZE,YCENTRE+SIZE}})
  --// Rotate the points 
 points = rotate(points2,{1,1,1},v)
 faces = 
 {
  points[1..4],
  points[5..8],
  {points[1],points[2],points[6],points[5]},
  {points[6],points[2],points[3],points[7]},
  {points[4],points[3],points[7],points[8]},
  {points[1],points[5],points[8],points[4]}  
 }
 --// Get the z-normals of the faces 
 zNormals = get_quad_zNormal(faces) 

 order = sort_faces(faces)
 faces = GetScreenXY(faces)

 for i = 1 to 6 do
   --// Is the face visible ? 
   if zNormals[order[i]]>=0 then
     foi = faces[order[i]]
     soi = shades[order[i]]
     c = (({foi[1][3],foi[2][3],foi[3][3],foi[4][3]}+P))/SPAN
     if BPP=8 then
       c1 = floor((c[1]+c[2]+c[3])*20)+soi[1]
       c2 = floor((c[1]+c[3]+c[4])*20)+soi[1]
     else 
       c1 = makecol(bits_per_pixel,floor(soi*((c[1]+c[2]+c[3])/3)))
       c2 = makecol(bits_per_pixel,floor(soi*((c[1]+c[3]+c[4])/3)))
     end if   
     draw_tri(foi[1..3],c1,vscreen)
     draw_tri({foi[1],foi[3],foi[4]},c2,vscreen)
   end if
 end for

 if wait_retrace then wait_vrt() end if
 single_copy(screen_copy, {vscreen, video_mem, XDIM*(BPP/8),YDIM, XDIM*(BPP/8), bytes_per_line})

 frames += 1
 v += dv
 for i = 1 to 3 do
   if v[i]>=361 then
     v[i] -= 360
   end if
   if v[i]<1 then
     v[i] += 360
   end if
 end for

 --// Randomize the rotation 
 if rand(150)=1 then
   dv = rand({6,6,6})-3
 end if
 if key='+' then
   camZ -= 10
 elsif key='-' then
   camZ += 10
 end if
end while


time2 = time()
if graphics_mode(-1) then end if
free(vscreen)

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))

