-- ..The worst set of vector routines ever written..
--                 By Mic, 1999/2000



constant vfix=3.14159265/180
constant zEye=-200

global integer camX,camY,camZ,Factor

camX = 160
camY = 100
camZ = -300
Factor = 256

sequence cosTb, sinTb
global sequence m19_centers,m19_orderTb

sinTb=repeat(0,360)
cosTb=sinTb
for i=1 to 360 do
 sinTb[i]=sin(i*vfix)
 cosTb[i]=cos(i*vfix)
end for

--** <Math routines> **--

--*** Return the absolute value of num1 ***--
global function m19abs(integer num1)
if (num1<0) then
num1=-num1
end if
return num1
end function

global function positive(object values,integer zeroPoint)
 if atom(values) then
  if (values<zeroPoint) then
   values=zeroPoint-values
  end if
  return values
 end if
 for i=1 to length(values) do
  if (values[i]<zeroPoint) then
   values[i]=zeroPoint-values[i]
  end if
 end for
 return values
end function

--*** Return the differance between two integers ( diff(-1,2)=3 ) ***--
global function diff(integer num1,integer num2)
integer retNum
if (num1>=0) and (num2>=0) then
retNum=m19abs(num1-num2)
end if
if (num1>=0) and (num2<0) then
retNum=num1+m19abs(num2)
end if
if (num1<0) and (num2>=0) then
retNum=m19abs(num1)+num2
end if
if (num1<0) and (num2<0) then
retNum=m19abs(num1-num2)
end if
return retNum
end function


--*** Convert 3d-coordinates to 2d ***--
global function get_screen_xy(sequence xy,sequence obj)
integer x0,y0
integer numFaces,facePoints
sequence retSeq
 numFaces=length(obj)
 facePoints=length(obj[1])
 retSeq=repeat(repeat({0,0},facePoints),numFaces)
 for i=1 to numFaces do
  for j=1 to facePoints do
   if -obj[i][j][3]!=camZ then
    x0=camX+floor(obj[i][j][1]*(camZ/(camZ-obj[i][j][3])))
    y0=camY+floor(obj[i][j][2]*(camZ/(camZ-obj[i][j][3])))
   else
    x0=camX
    y0=camY
   end if
   retSeq[i][j]={x0,y0}
  end for
 end for
 return retSeq
end function

global function GetScreenXY(sequence point)
integer x0,y0
integer numFaces,facePoints
sequence retSeq,rs_i,point_ij,xy0
atom point_ij_add_z
 numFaces = length(point)
 facePoints = length(point[1])
 retSeq=repeat(repeat({0,0},facePoints),numFaces)
 for i = 1 to numFaces do
--  rs_i = retSeq[i]
  for j=1 to facePoints do
   point_ij=point[i][j]
   point_ij_add_z=point_ij[3]+camZ
   if -point_ij[3]!=camZ then
    xy0={floor(camX+((Factor*point_ij[1])/point_ij_add_z)),
        floor(camY+((Factor*point_ij[2])/point_ij_add_z)),point_ij[3]}
   else
    xy0={camX,camY,point_ij[3]}
   end if
   retSeq[i][j]=xy0
  end for
 end for
 return retSeq
end function


--*** Sort an array of faces ***--
global function sort_faces(sequence obj)
integer pos
atom tempval
integer numFaces,facePoints
  obj = -obj
  facePoints = length(obj[1])
  numFaces = length(obj)
  m19_centers = repeat(0,numFaces)
  m19_orderTb = m19_centers
  for i=1 to numFaces do
   for j = 1 to facePoints do
     m19_centers[i] = m19_centers[i]+obj[i][j][3]
   end for
  end for
  for i=1 to numFaces do
    m19_orderTb[i]=i
  end for
  pos=1
  for i=1 to numFaces do
   for j=(i+1) to numFaces do
     if m19_centers[j]>m19_centers[i] then
       tempval = m19_centers[j]
       m19_centers[j] = m19_centers[i]
       m19_centers[i] = tempval
       tempval = m19_orderTb[j]
       m19_orderTb[j] = m19_orderTb[i]
       m19_orderTb[i] = tempval
     end if
    end for
  end for
  return m19_orderTb
end function


function rotate_point(sequence point,sequence toRotate,sequence a)
atom xr,yr,zr
 if toRotate[1]=1 then
  yr=(cosTb[a[1]]*point[2])-(sinTb[a[1]]*point[3])
  zr=(sinTb[a[1]]*point[2])+(cosTb[a[1]]*point[3])
  point[2..3]={yr,zr}
 end if
 if toRotate[2]=1 then
  xr=(cosTb[a[2]]*point[1])-(sinTb[a[2]]*point[3])
  zr=(sinTb[a[2]]*point[1])+(cosTb[a[2]]*point[3])
  point[1]=xr
  point[3]=zr
 end if
 if toRotate[3]=1 then
  xr=(cosTb[a[3]]*point[1])-(sinTb[a[3]]*point[2])
  yr=(sinTb[a[3]]*point[1])+(cosTb[a[3]]*point[2])
  point[1..2]={xr,yr}
 end if
 return point
end function


--*** Rotate a sequence of points ***--
global function rotate(sequence obj,sequence toRotate,sequence a)
atom xr,yr,zr
integer objPoints
 --a=positive(remainder(a,360),360)+1
 if atom(obj[1]) then
  return rotate_point(obj,toRotate,a)
 end if
 objPoints=length(obj)
 for i=1 to objPoints do
  if toRotate[1]=1 then
   yr=(cosTb[a[1]]*obj[i][2])-(sinTb[a[1]]*obj[i][3])
   zr=(sinTb[a[1]]*obj[i][2])+(cosTb[a[1]]*obj[i][3])
   obj[i][2..3]={yr,zr}
  end if
  if toRotate[2]=1 then
   xr=(cosTb[a[2]]*obj[i][1])-(sinTb[a[2]]*obj[i][3])
   zr=(sinTb[a[2]]*obj[i][1])+(cosTb[a[2]]*obj[i][3])
   obj[i][1]=xr
   obj[i][3]=zr
  end if
  if toRotate[3]=1 then
   xr=(cosTb[a[3]]*obj[i][1])-(sinTb[a[3]]*obj[i][2])
   yr=(sinTb[a[3]]*obj[i][1])+(cosTb[a[3]]*obj[i][2])
   obj[i][1..2]={xr,yr}
  end if
 end for
 return obj
end function


global function backface_cull(sequence obj)
atom dx1,dx2,dy1,dy2
sequence culled
 culled=repeat(1,length(obj))
 for i=1 to length(obj) do
  dx1=obj[i][3][1]-obj[i][1][1]
  dy1=obj[i][3][2]-obj[i][1][2]
  dx2=obj[i][3][1]-obj[i][2][1]
  dy2=obj[i][3][2]-obj[i][2][2]
  if (((dx1*(dy2-dy1))-((dx2-dx1)*dy1))>=0) then
   culled[i]=0
  --else
  -- culled=culled & 1
  end if
 end for
 return culled
end function


global function get_quad_zNormal(sequence d3Coords)
sequence retNorm
integer numFaces
 numFaces=length(d3Coords) 
 retNorm=repeat(0,numFaces)
 for i=1 to numFaces do
--  retNorm[i]=(d3Coords[i][1][3]+d3Coords[i][3][3])
  retNorm[i]=(d3Coords[i][1][3]+d3Coords[i][2][3]+d3Coords[i][3][3]+d3Coords[i][4][3])
  --retNorm[i]=(retNorm[i]/m19abs(retNorm[i]))
 end for
return retNorm
end function

--** </Math routines> **--